[SOLVED] Picard can't save tags. error: [Errno 38] Function not implemented

picard
ubuntu
Tags: #<Tag:0x00007f11cc36cc18> #<Tag:0x00007f11cc36c678>

#1

I.m using Picard 2.0.4 flatpak in Ubuntu 18.10. Every time I try to save, I get this error message.

error: [Errno 38] Function not implemented

What could be causing this?


#2

Not sure about this, maybe something special with your file system?

Please take a look at Help > View Error/Debug Log after this issue has happened and post the output from there here. This should give us some info on where exactly this error is raised.

Also can you give some details about your setup? What file system(s) do you use? Where do you save the files to (local disk, network drive)?


#3
E: 13:57:40,484 /app/lib/python3.5/site-packages/picard/util/thread.run:51: Traceback (most recent call last):
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 169, in wrapper
return func(*args, **kwargs)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 140, in wrapper
return func(self, h, *args, **kwargs)
File "/app/lib/python3.5/site-packages/mutagen/asf/__init__.py", line 314, in save
resize_bytes(fileobj, old_size, size, 0)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 916, in resize_bytes
insert_bytes(fobj, insert_size, insert_at)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 849, in insert_bytes
resize_file(fobj, size, BUFFER_SIZE)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 768, in resize_file
fobj.write(b"\x00" * addsize)
OSError: [Errno 38] Function not implemented
During handling of the above exception, another exception occurred:
Traceback (most recent call last):
File "/app/lib/python3.5/site-packages/picard/util/thread.py", line 47, in run
result = self.func()
File "/app/lib/python3.5/site-packages/picard/file.py", line 210, in _save_and_rename
self._save(old_filename, metadata)
File "/app/lib/python3.5/site-packages/picard/formats/asf.py", line 216, in _save
file.save()
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 173, in wrapper
reraise(exc_dest, err, sys.exc_info()[2])
File "/app/lib/python3.5/site-packages/mutagen/_compat.py", line 86, in reraise
raise tp(value).with_traceback(tb)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 169, in wrapper
return func(*args, **kwargs)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 140, in wrapper
return func(self, h, *args, **kwargs)
File "/app/lib/python3.5/site-packages/mutagen/asf/__init__.py", line 314, in save
resize_bytes(fileobj, old_size, size, 0)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 916, in resize_bytes
insert_bytes(fobj, insert_size, insert_at)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 849, in insert_bytes
resize_file(fobj, size, BUFFER_SIZE)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 768, in resize_file
fobj.write(b"\x00" * addsize)
mutagen.asf._util.error: [Errno 38] Function not implemented
E: 13:57:40,497 /app/lib/python3.5/site-packages/picard/util/thread.run:51: Traceback (most recent call last):
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 169, in wrapper
return func(*args, **kwargs)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 140, in wrapper
return func(self, h, *args, **kwargs)
File "/app/lib/python3.5/site-packages/mutagen/asf/__init__.py", line 314, in save
resize_bytes(fileobj, old_size, size, 0)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 916, in resize_bytes
insert_bytes(fobj, insert_size, insert_at)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 849, in insert_bytes
resize_file(fobj, size, BUFFER_SIZE)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 768, in resize_file
fobj.write(b"\x00" * addsize)
OSError: [Errno 38] Function not implemented
During handling of the above exception, another exception occurred:
Traceback (most recent call last):
File "/app/lib/python3.5/site-packages/picard/util/thread.py", line 47, in run
result = self.func()
File "/app/lib/python3.5/site-packages/picard/file.py", line 210, in _save_and_rename
self._save(old_filename, metadata)
File "/app/lib/python3.5/site-packages/picard/formats/asf.py", line 216, in _save
file.save()
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 173, in wrapper
reraise(exc_dest, err, sys.exc_info()[2])
File "/app/lib/python3.5/site-packages/mutagen/_compat.py", line 86, in reraise
raise tp(value).with_traceback(tb)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 169, in wrapper
return func(*args, **kwargs)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 140, in wrapper
return func(self, h, *args, **kwargs)
File "/app/lib/python3.5/site-packages/mutagen/asf/__init__.py", line 314, in save
resize_bytes(fileobj, old_size, size, 0)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 916, in resize_bytes
insert_bytes(fobj, insert_size, insert_at)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 849, in insert_bytes
resize_file(fobj, size, BUFFER_SIZE)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 768, in resize_file
fobj.write(b"\x00" * addsize)
mutagen.asf._util.error: [Errno 38] Function not implemented
E: 13:57:40,502 /app/lib/python3.5/site-packages/picard/util/thread.run:51: Traceback (most recent call last):
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 169, in wrapper
return func(*args, **kwargs)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 140, in wrapper
return func(self, h, *args, **kwargs)
File "/app/lib/python3.5/site-packages/mutagen/asf/__init__.py", line 314, in save
resize_bytes(fileobj, old_size, size, 0)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 916, in resize_bytes
insert_bytes(fobj, insert_size, insert_at)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 849, in insert_bytes
resize_file(fobj, size, BUFFER_SIZE)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 768, in resize_file
fobj.write(b"\x00" * addsize)
OSError: [Errno 38] Function not implemented
During handling of the above exception, another exception occurred:
Traceback (most recent call last):
File "/app/lib/python3.5/site-packages/picard/util/thread.py", line 47, in run
result = self.func()
File "/app/lib/python3.5/site-packages/picard/file.py", line 210, in _save_and_rename
self._save(old_filename, metadata)
File "/app/lib/python3.5/site-packages/picard/formats/asf.py", line 216, in _save
file.save()
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 173, in wrapper
reraise(exc_dest, err, sys.exc_info()[2])
File "/app/lib/python3.5/site-packages/mutagen/_compat.py", line 86, in reraise
raise tp(value).with_traceback(tb)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 169, in wrapper
return func(*args, **kwargs)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 140, in wrapper
return func(self, h, *args, **kwargs)
File "/app/lib/python3.5/site-packages/mutagen/asf/__init__.py", line 314, in save
resize_bytes(fileobj, old_size, size, 0)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 916, in resize_bytes
insert_bytes(fobj, insert_size, insert_at)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 849, in insert_bytes
resize_file(fobj, size, BUFFER_SIZE)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 768, in resize_file
fobj.write(b"\x00" * addsize)
mutagen.asf._util.error: [Errno 38] Function not implemented
E: 13:57:40,508 /app/lib/python3.5/site-packages/picard/util/thread.run:51: Traceback (most recent call last):
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 169, in wrapper
return func(*args, **kwargs)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 140, in wrapper
return func(self, h, *args, **kwargs)
File "/app/lib/python3.5/site-packages/mutagen/asf/__init__.py", line 314, in save
resize_bytes(fileobj, old_size, size, 0)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 916, in resize_bytes
insert_bytes(fobj, insert_size, insert_at)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 849, in insert_bytes
resize_file(fobj, size, BUFFER_SIZE)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 768, in resize_file
fobj.write(b"\x00" * addsize)
OSError: [Errno 38] Function not implemented
During handling of the above exception, another exception occurred:
Traceback (most recent call last):
File "/app/lib/python3.5/site-packages/picard/util/thread.py", line 47, in run
result = self.func()
File "/app/lib/python3.5/site-packages/picard/file.py", line 210, in _save_and_rename
self._save(old_filename, metadata)
File "/app/lib/python3.5/site-packages/picard/formats/asf.py", line 216, in _save
file.save()
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 173, in wrapper
reraise(exc_dest, err, sys.exc_info()[2])
File "/app/lib/python3.5/site-packages/mutagen/_compat.py", line 86, in reraise
raise tp(value).with_traceback(tb)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 169, in wrapper
return func(*args, **kwargs)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 140, in wrapper
return func(self, h, *args, **kwargs)
File "/app/lib/python3.5/site-packages/mutagen/asf/__init__.py", line 314, in save
resize_bytes(fileobj, old_size, size, 0)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 916, in resize_bytes
insert_bytes(fobj, insert_size, insert_at)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 849, in insert_bytes
resize_file(fobj, size, BUFFER_SIZE)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 768, in resize_file
fobj.write(b"\x00" * addsize)
mutagen.asf._util.error: [Errno 38] Function not implemented
E: 13:57:40,514 /app/lib/python3.5/site-packages/picard/util/thread.run:51: Traceback (most recent call last):
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 169, in wrapper
return func(*args, **kwargs)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 140, in wrapper
return func(self, h, *args, **kwargs)
File "/app/lib/python3.5/site-packages/mutagen/asf/__init__.py", line 314, in save
resize_bytes(fileobj, old_size, size, 0)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 916, in resize_bytes
insert_bytes(fobj, insert_size, insert_at)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 849, in insert_bytes
resize_file(fobj, size, BUFFER_SIZE)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 768, in resize_file
fobj.write(b"\x00" * addsize)
OSError: [Errno 38] Function not implemented
During handling of the above exception, another exception occurred:
Traceback (most recent call last):
File "/app/lib/python3.5/site-packages/picard/util/thread.py", line 47, in run
result = self.func()
File "/app/lib/python3.5/site-packages/picard/file.py", line 210, in _save_and_rename
self._save(old_filename, metadata)
File "/app/lib/python3.5/site-packages/picard/formats/asf.py", line 216, in _save
file.save()
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 173, in wrapper
reraise(exc_dest, err, sys.exc_info()[2])
File "/app/lib/python3.5/site-packages/mutagen/_compat.py", line 86, in reraise
raise tp(value).with_traceback(tb)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 169, in wrapper
return func(*args, **kwargs)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 140, in wrapper
return func(self, h, *args, **kwargs)
File "/app/lib/python3.5/site-packages/mutagen/asf/__init__.py", line 314, in save
resize_bytes(fileobj, old_size, size, 0)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 916, in resize_bytes
insert_bytes(fobj, insert_size, insert_at)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 849, in insert_bytes
resize_file(fobj, size, BUFFER_SIZE)
File "/app/lib/python3.5/site-packages/mutagen/_util.py", line 768, in resize_file
fobj.write(b"\x00" * addsize)
mutagen.asf._util.error: [Errno 38] Function not implemented

I save my files in the local disk with NTFS file system.


#4

I suspect some issue with the mounted NTFS file system. Can you post the output of mount?


#5

I don’t know how to do that. Can you provide the instructions?


#6

Please open a terminal and type

mount

Press Enter. It will list all the mounted filesystems. Don’t worry if this list looks longer than expected, in a modern Linux there are a couple of virtual filesystem. Just paste the entire thing here and we can sort out which filesystems could be relevant and which not.


#7
sysfs on /sys type sysfs (rw,nosuid,nodev,noexec,relatime)
proc on /proc type proc (rw,nosuid,nodev,noexec,relatime)
udev on /dev type devtmpfs (rw,nosuid,relatime,size=4010536k,nr_inodes=1002634,mode=755)
devpts on /dev/pts type devpts (rw,nosuid,noexec,relatime,gid=5,mode=620,ptmxmode=000)
tmpfs on /run type tmpfs (rw,nosuid,noexec,relatime,size=806604k,mode=755)
/dev/sdb7 on / type ext4 (rw,relatime,errors=remount-ro)
securityfs on /sys/kernel/security type securityfs (rw,nosuid,nodev,noexec,relatime)
tmpfs on /dev/shm type tmpfs (rw,nosuid,nodev)
tmpfs on /run/lock type tmpfs (rw,nosuid,nodev,noexec,relatime,size=5120k)
tmpfs on /sys/fs/cgroup type tmpfs (ro,nosuid,nodev,noexec,mode=755)
cgroup2 on /sys/fs/cgroup/unified type cgroup2 (rw,nosuid,nodev,noexec,relatime,nsdelegate)
cgroup on /sys/fs/cgroup/systemd type cgroup (rw,nosuid,nodev,noexec,relatime,xattr,name=systemd)
pstore on /sys/fs/pstore type pstore (rw,nosuid,nodev,noexec,relatime)
efivarfs on /sys/firmware/efi/efivars type efivarfs (rw,nosuid,nodev,noexec,relatime)
bpf on /sys/fs/bpf type bpf (rw,nosuid,nodev,noexec,relatime,mode=700)
cgroup on /sys/fs/cgroup/freezer type cgroup (rw,nosuid,nodev,noexec,relatime,freezer)
cgroup on /sys/fs/cgroup/net_cls,net_prio type cgroup (rw,nosuid,nodev,noexec,relatime,net_cls,net_prio)
cgroup on /sys/fs/cgroup/devices type cgroup (rw,nosuid,nodev,noexec,relatime,devices)
cgroup on /sys/fs/cgroup/blkio type cgroup (rw,nosuid,nodev,noexec,relatime,blkio)
cgroup on /sys/fs/cgroup/memory type cgroup (rw,nosuid,nodev,noexec,relatime,memory)
cgroup on /sys/fs/cgroup/cpu,cpuacct type cgroup (rw,nosuid,nodev,noexec,relatime,cpu,cpuacct)
cgroup on /sys/fs/cgroup/perf_event type cgroup (rw,nosuid,nodev,noexec,relatime,perf_event)
cgroup on /sys/fs/cgroup/pids type cgroup (rw,nosuid,nodev,noexec,relatime,pids)
cgroup on /sys/fs/cgroup/hugetlb type cgroup (rw,nosuid,nodev,noexec,relatime,hugetlb)
cgroup on /sys/fs/cgroup/rdma type cgroup (rw,nosuid,nodev,noexec,relatime,rdma)
cgroup on /sys/fs/cgroup/cpuset type cgroup (rw,nosuid,nodev,noexec,relatime,cpuset)
systemd-1 on /proc/sys/fs/binfmt_misc type autofs (rw,relatime,fd=33,pgrp=1,timeout=0,minproto=5,maxproto=5,direct,pipe_ino=14655)
mqueue on /dev/mqueue type mqueue (rw,relatime)
debugfs on /sys/kernel/debug type debugfs (rw,relatime)
hugetlbfs on /dev/hugepages type hugetlbfs (rw,relatime,pagesize=2M)
/var/lib/snapd/snaps/core18_442.snap on /snap/core18/442 type squashfs (ro,nodev,relatime,x-gdu.hide)
/var/lib/snapd/snaps/gnome-3-26-1604_70.snap on /snap/gnome-3-26-1604/70 type squashfs (ro,nodev,relatime,x-gdu.hide)
/var/lib/snapd/snaps/gnome-logs_45.snap on /snap/gnome-logs/45 type squashfs (ro,nodev,relatime,x-gdu.hide)
/var/lib/snapd/snaps/mpv_1.snap on /snap/mpv/1 type squashfs (ro,nodev,relatime,x-gdu.hide)
/var/lib/snapd/snaps/gnome-3-26-1604_74.snap on /snap/gnome-3-26-1604/74 type squashfs (ro,nodev,relatime,x-gdu.hide)
/var/lib/snapd/snaps/gnome-calculator_238.snap on /snap/gnome-calculator/238 type squashfs (ro,nodev,relatime,x-gdu.hide)
/var/lib/snapd/snaps/gnome-system-monitor_57.snap on /snap/gnome-system-monitor/57 type squashfs (ro,nodev,relatime,x-gdu.hide)
/var/lib/snapd/snaps/gnome-characters_139.snap on /snap/gnome-characters/139 type squashfs (ro,nodev,relatime,x-gdu.hide)
/var/lib/snapd/snaps/handbrake-jz_134.snap on /snap/handbrake-jz/134 type squashfs (ro,nodev,relatime,x-gdu.hide)
configfs on /sys/kernel/config type configfs (rw,relatime)
fusectl on /sys/fs/fuse/connections type fusectl (rw,relatime)
/var/lib/snapd/snaps/core_5662.snap on /snap/core/5662 type squashfs (ro,nodev,relatime,x-gdu.hide)
/var/lib/snapd/snaps/gnome-characters_124.snap on /snap/gnome-characters/124 type squashfs (ro,nodev,relatime,x-gdu.hide)
/var/lib/snapd/snaps/gnome-chess_29.snap on /snap/gnome-chess/29 type squashfs (ro,nodev,relatime,x-gdu.hide)
/var/lib/snapd/snaps/gtk-common-themes_701.snap on /snap/gtk-common-themes/701 type squashfs (ro,nodev,relatime,x-gdu.hide)
/var/lib/snapd/snaps/vlc_555.snap on /snap/vlc/555 type squashfs (ro,nodev,relatime,x-gdu.hide)
/var/lib/snapd/snaps/core_5742.snap on /snap/core/5742 type squashfs (ro,nodev,relatime,x-gdu.hide)
/var/lib/snapd/snaps/core18_437.snap on /snap/core18/437 type squashfs (ro,nodev,relatime,x-gdu.hide)
/var/lib/snapd/snaps/telegram-desktop_291.snap on /snap/telegram-desktop/291 type squashfs (ro,nodev,relatime,x-gdu.hide)
/var/lib/snapd/snaps/keepassxc_49.snap on /snap/keepassxc/49 type squashfs (ro,nodev,relatime,x-gdu.hide)
/var/lib/snapd/snaps/0ad_50.snap on /snap/0ad/50 type squashfs (ro,nodev,relatime,x-gdu.hide)
/dev/sdb8 on /home type ext4 (rw,relatime)
/dev/sdb9 on /media/user/Vol-1 type fuseblk (rw,nosuid,nodev,relatime,user_id=0,group_id=0,allow_other,blksize=4096,x-gvfs-show)
/dev/sdb2 on /boot/efi type vfat (rw,relatime,fmask=0022,dmask=0022,codepage=437,iocharset=iso8859-1,shortname=mixed,errors=remount-ro)
/dev/sdb10 on /media/user/Vol-2 type fuseblk (rw,nosuid,nodev,relatime,user_id=0,group_id=0,allow_other,blksize=4096,x-gvfs-show)
/dev/sdb11 on /media/user/Vol-3 type fuseblk (rw,nosuid,nodev,relatime,user_id=0,group_id=0,allow_other,blksize=4096,x-gvfs-show)
tmpfs on /run/user/1000 type tmpfs (rw,nosuid,nodev,relatime,size=806600k,mode=700,uid=1000,gid=1000)
gvfsd-fuse on /run/user/1000/gvfs type fuse.gvfsd-fuse (rw,nosuid,nodev,relatime,user_id=1000,group_id=1000)
tmpfs on /run/snapd/ns type tmpfs (rw,nosuid,noexec,relatime,size=806604k,mode=755)
nsfs on /run/snapd/ns/keepassxc.mnt type nsfs (rw)

FYI my music collection is in Vol-3.

Update 1: I managed to save MP3 files in an EXT4 partition without any trouble. The error occurs when trying to save WMA files in an NTFS partition. I’m not sure where the problem is.

Update 2: I moved the WMA files to the EXT4 partition & it worked fine. I think you are right. It may be a problem with the mounted filesystem. Any advice?


#8

After some digging I managed to figure it out. It’s not a problem with the filesystem. Flatpaks are sandboxed & by default they only use the home directory. You have to manually grant the flatpak permissions to use more resources. The following command worked for me.

sudo flatpak override --filesystem=/path/to/the/other/partition/ org.musicbrainz.Picard

The manpages are available here.